-- initialize the ShoppingListTab class
ShoppingListTab = inheritsFrom(Frame)

function ShoppingListTab:new(parent)

	local tab = Frame:new(nil, parent)
	setmetatable(tab, { __index = ShoppingListTab })
	tab:SetPoint("TOPLEFT")
	tab:SetPoint("BOTTOMRIGHT")
	tab:Hide()
	tab:RegisterEvent("AUCTION_HOUSE_CLOSED")
	tab:RegisterEvent("AUCTION_HOUSE_SHOW")


   	-- tab:RegisterEvent("CHAT_MSG_CHANNEL")
   	-- tab:RegisterEvent("CHAT_MSG_GUILD")
   	-- tab:RegisterEvent("CHAT_MSG_PARTY")
   	-- tab:RegisterEvent("CHAT_MSG_PARTY_LEADER")
   	-- tab:RegisterEvent("CHAT_MSG_RAID")

	tab.isAuctionHouseVisible = false

	tab:SetScript("OnEvent", function(...)
		tab:OnEvent(...)
	end)

	tab.shoppingListHeader = FontString:new(tab, nil, "ARTWORK", "GameFontNormalLarge")
	tab.shoppingListHeader:SetPoint("TOPLEFT", 0, -5)
	tab.shoppingListHeader:SetText("Shopping List")

	tab.shoppingPanel = Frame:new(nil, tab)
	tab.shoppingPanel:SetPoint("TOPLEFT", tab.shoppingListHeader, "BOTTOMLEFT", 0, -10)
	tab.shoppingPanel:SetPoint("BOTTOMRIGHT", tab, "BOTTOMRIGHT", -20, 17)


	tab.sendButton = CreateFrame("Button", "AmrSendButton", tab.shoppingPanel, "UIPanelButtonTemplate")
	tab.sendButton:SetText("send it!")
	tab.sendButton:SetPoint("BOTTOMLEFT", 0, 0)
	tab.sendButton:SetHeight(25)
	tab.sendButton:SetNormalFontObject("GameFontNormalLarge")
	tab.sendButton:SetHighlightFontObject("GameFontHighlightLarge")
	tab.sendButton:SetWidth(150)
	tab.sendButton:SetScript("OnClick", function()
		tab:Send()
	end)


	tab.enchantMaterialsCheckbox = CreateFrame("CheckButton", "AmrEnchantMaterialsCheckbox", tab.shoppingPanel, "ChatConfigCheckButtonTemplate");
	tab.enchantMaterialsCheckbox:SetChecked(AmrSendSettings.SendEnchantMaterials)
	tab.enchantMaterialsCheckbox:SetScript("OnClick", function () AmrSendSettings.SendEnchantMaterials = tab.enchantMaterialsCheckbox:GetChecked() end)
	tab.enchantMaterialsCheckbox:SetPoint("TOPLEFT", tab.sendButton, "TOPLEFT", 0, 25)
	local text3 = getglobal(tab.enchantMaterialsCheckbox:GetName() .. 'Text')
	text3:SetFontObject("GameFontHighlightLarge")
	text3:SetText("Enchant Materials")
	text3:SetWidth(150)
	text3:SetPoint("TOPLEFT", tab.enchantMaterialsCheckbox, "TOPRIGHT", 2, -4)


	tab.enchantsCheckbox = CreateFrame("CheckButton", "AmrEnchantsCheckbox", tab.shoppingPanel, "ChatConfigCheckButtonTemplate");
	tab.enchantsCheckbox:SetChecked(AmrSendSettings.SendEnchants)
	tab.enchantsCheckbox:SetScript("OnClick", function () AmrSendSettings.SendEnchants = tab.enchantsCheckbox:GetChecked() end)
	tab.enchantsCheckbox:SetPoint("TOPLEFT", tab.sendButton, "TOPLEFT", 0, 50)
	local text2 = getglobal(tab.enchantsCheckbox:GetName() .. 'Text')
	text2:SetFontObject("GameFontHighlightLarge")
	text2:SetText("Enchants")
	text2:SetWidth(150)
	text2:SetPoint("TOPLEFT", tab.enchantsCheckbox, "TOPRIGHT", 2, -4)



	tab.gemsCheckbox = CreateFrame("CheckButton", "AmrGemsCheckbox", tab.shoppingPanel, "ChatConfigCheckButtonTemplate");
	tab.gemsCheckbox:SetPoint("TOPLEFT", tab.sendButton, "TOPLEFT", 0, 75)
	tab.gemsCheckbox:SetChecked(AmrSendSettings.SendGems)
	tab.gemsCheckbox:SetScript("OnClick", function () AmrSendSettings.SendGems = tab.gemsCheckbox:GetChecked() end)
	local text = getglobal(tab.gemsCheckbox:GetName() .. 'Text')
	text:SetFontObject("GameFontHighlightLarge")
	text:SetText("Gems")
	text:SetWidth(150)
	text:SetPoint("TOPLEFT", tab.gemsCheckbox, "TOPRIGHT", 2, -4)


	tab.sendMessage4 = FontString:new(tab.shoppingPanel, nil, "ARTWORK", "GameFontHighlightLarge")
	tab.sendMessage4:SetText("Include:")
	tab.sendMessage4:SetPoint("TOPLEFT", tab.gemsCheckbox, "TOPLEFT", 0, 20)


	tab.sendMessage3 = FontString:new(tab.shoppingPanel, nil, "ARTWORK", "GameFontHighlightLarge")
	tab.sendMessage3:SetText("Send list to")
	tab.sendMessage3:SetPoint("TOPLEFT", tab.sendMessage4, "TOPLEFT", 0, 25)


	tab.sendMessage2 = FontString:new(tab.shoppingPanel, nil, "ARTWORK", "GameFontNormal")
	tab.sendMessage2:SetTextColor(.5,.5,.5)
	tab.sendMessage2:SetText("Whisper to a friend or send to a channel, like /raid or /guild.")
	tab.sendMessage2:SetPoint("TOPLEFT", tab.sendMessage3, "TOPLEFT", 0, 25)


	tab.sendMessage1 = FontString:new(tab.shoppingPanel, nil, "ARTWORK", "GameFontNormalLarge")
	tab.sendMessage1:SetTextColor(0,1,0)
	tab.sendMessage1:SetText("Send to a Jewelcraft or Enchanter friend :)")
	tab.sendMessage1:SetPoint("TOPLEFT", tab.sendMessage2, "TOPLEFT", 0, 25)


	tab.scrollFrame = CreateFrame("ScrollFrame", "AmrScrollFrame", tab.shoppingPanel, "UIPanelScrollFrameTemplate")
	tab.scrollFrame:SetPoint("TOPLEFT", 0, 0)
	tab.scrollFrame:SetPoint("RIGHT", -20, 0)
	tab.scrollFrame:SetPoint("BOTTOM", tab.sendMessage1, "TOP", 0, 10)

	tab.scrollParent = Frame:new(nil, tab.shoppingPanel)
	tab.scrollParent:SetPoint("TOPLEFT", 0, 0)
	tab.scrollParent:SetWidth(tab:GetWidth() - 20)
	tab.scrollParent:SetHeight(500)
	tab.scrollFrame:SetScrollChild(tab.scrollParent)

	-- magic to get the scrollbar to work with the scrollwheel...
	tab.scrollFrame:SetScript("OnMouseWheel", function(arg1, arg2)
	 	ScrollFrameTemplate_OnMouseWheel(arg1, arg2, arg1.ScrollBar)
	end)

	tab.gemsHeader = FontString:new(tab.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
	tab.gemsHeader:SetText("Gems")
	tab.gemsHeader:SetPoint("TOPLEFT", tab.scrollParent, "TOPLEFT", 0, 0)

	tab.gemsQuantityHeader = FontString:new(tab.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
	tab.gemsQuantityHeader:SetText("Total")
	tab.gemsQuantityHeader:SetPoint("TOPLEFT", tab.scrollParent, "TOPLEFT", 370, 0)

	tab.enchantsHeader = FontString:new(tab.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
	tab.enchantsHeader:SetText("Enchants")

	tab.enchantsQuantityHeader = FontString:new(tab.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
	tab.enchantsQuantityHeader:SetText("Total")
	tab.enchantsQuantityHeader:SetPoint("TOPLEFT", tab.enchantsHeader, "TOPLEFT", 370, 0)

	tab.enchantMaterialsHeader = FontString:new(tab.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
	tab.enchantMaterialsHeader:SetText("Enchant Materials")

	tab.enchantMaterialsQuantityHeader = FontString:new(tab.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
	tab.enchantMaterialsQuantityHeader:SetText("Total")
	tab.enchantMaterialsQuantityHeader:SetPoint("TOPLEFT", tab.enchantMaterialsHeader, "TOPLEFT", 370, 0)

	tab.stamp = RobotStamp:new(nil, tab)
	tab.stamp:Hide()
	tab.stamp.bigText:SetText("YOUR SHOPPING IS ALL DONE!")
	tab.stamp.smallText:SetText("Unless you want to buy me a birthday present! I like titanium bolts and robot dogs... Or was it titanium dogs and robot bolts...")
	tab.stamp:SetPoint("TOPLEFT", tab.shoppingListHeader, "BOTTOMLEFT", 2, -15)
	tab.stamp:SetPoint("RIGHT", tab, "RIGHT", -30, 0)
	tab.stamp:SetHeight(92)

	tab.gemIcons = {}
	tab.gemLinks = {}
	tab.gemQuantity = {}
	tab.enchantIcons = {}
	tab.enchantLinks = {}
	tab.enchantQuantity = {}
	tab.enchantMaterialIcons = {}
	tab.enchantMaterialLinks = {}
	tab.enchantMaterialQuantity = {}

	-- Create the dropdown, and configure its appearance
	tab.dropDown = CreateFrame("FRAME", "AmrSendType", tab.shoppingPanel, "UIDropDownMenuTemplate")
	tab.dropDown:SetPoint("TOPLEFT", tab.sendMessage3, "TOPRIGHT", 0, 5)
	UIDropDownMenu_SetWidth(tab.dropDown, 140)
	UIDropDownMenu_SetText(tab.dropDown, AmrSendSettings.SendToType)

	local text = getglobal(tab.dropDown:GetName() .. 'Text')
	text:SetFontObject("GameFontHighlightLarge")

	local AddButton = function(list, optionText)
		local info = UIDropDownMenu_CreateInfo()
		info.justifyH = "RIGHT"
		info.text = optionText
		info.checked = AmrSendSettings.SendToType == optionText
		info.arg1 = optionText
		info.func = list.SetValue
		info.owner = list
		info.fontObject = "GameFontHighlightLarge"
		info.minWidth = 140
		return info
	end

	-- Create and bind the initialization function to the dropdown menu
	UIDropDownMenu_Initialize(tab.dropDown, function(self, level, menuList)
	 UIDropDownMenu_AddButton(AddButton(self, "a friend"))
	 UIDropDownMenu_AddButton(AddButton(self, "party"))
	 UIDropDownMenu_AddButton(AddButton(self, "raid"))
	 UIDropDownMenu_AddButton(AddButton(self, "guild"))
	 UIDropDownMenu_AddButton(AddButton(self, "channel"))
	end)

	function tab.dropDown:SetValue(newValue)
		AmrSendSettings.SendToType = newValue
		-- Update the text; if we merely wanted it to display newValue, we would not need to do this
		UIDropDownMenu_SetText(tab.dropDown, AmrSendSettings.SendToType)
		-- Because this is called from a sub-menu, only that menu level is closed by default.
		-- Close the entire menu with this next call
		CloseDropDownMenus()
	end

	tab.sendTo = CreateFrame("EditBox", "AmrSendTo", tab.shoppingPanel, "InputBoxTemplate" )
	tab.sendTo:SetPoint("TOPLEFT", tab.dropDown, "TOPRIGHT", 0, 0)
	tab.sendTo:SetPoint("RIGHT", 0, 0)
	tab.sendTo:SetHeight(30)
	tab.sendTo:SetText(AmrSendSettings.SendTo or "")
	tab.sendTo:SetFontObject("GameFontHighlightLarge")
	tab.sendTo:SetScript("OnChar", function()
		AmrSendSettings.SendTo = tab.sendTo:GetText()
	end)


	tab.messageQueue = {}
	tab.outstandingMessage = 0
	return tab
end

-- display a gem icon in a row
-- gemInfo is {id, enchantId, color, count }
function ShoppingListTab:SetGemIcon(row, gemInfo)
	-- get gem icon for the row
	local gemIcon = self.gemIcons[row]

	-- if we don't have one
	if gemIcon == nil then
		-- make one
		gemIcon = GemIcon:new(nil, self.scrollParent)
		self.gemIcons[row] = gemIcon
		gemIcon:SetScript("OnMouseDown", function()
			self:SearchForGem(row)
		end)

		-- position it
		local previous = self.gemsHeader
		if row > 1 then
			previous = self.gemIcons[row - 1]
		end
		gemIcon:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 0, -7)

		-- size it
		gemIcon:SetWidth(24)
		gemIcon:SetHeight(24)

		-- give it a nice border
		gemIcon:SetRoundBorder()
	end

	gemIcon:Show()

	-- make a link for the optimized gem
	gemLink = select(2, GetItemInfo(gemInfo.id))

	-- set the link (tooltip + icon)
	gemIcon:SetItemLink(gemLink)
	gemIcon:SetGemColor(gemInfo.color)

	-- if we didn't get one, its because WoW is slow
	if not gemLink and gemInfo.id and itemId then
		-- when WoW finally returns the link, set the icon / tooltip
		RegisterItemInfoCallback(itemId, function(name, link)
			gemIcon:SetItemLink(link)
		end)
	end

end


-- display a gem icon in a row
-- gemInfo is {id, enchantId, color, count }
function ShoppingListTab:SetGemText(row, gemInfo)
	-- get gem icon for the row
	local gemText = self.gemLinks[row]

	-- if we don't have one
	if gemText == nil then
		-- make one
		gemText = ItemLinkText:new(nil, self.scrollParent)
		self.gemLinks[row] = gemText
		gemText:SetScript("OnMouseDown", function()
			self:SearchForGem(row)
		end)	

		-- position it
		local previous = self.gemsHeader
		if row > 1 then
			previous = self.gemIcons[row - 1]
		end
		gemText:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 30, -8)
		gemText:SetPoint("RIGHT", self, "RIGHT", -70, 0)
		gemText:SetHeight(18)
		gemText:SetFontSize(15)
	end

	gemText:Show()

	gemText:SetItemId(gemInfo.id)
end

-- display a gem icon in a row
-- gemInfo is {id, enchantId, color, count }
function ShoppingListTab:SetGemQuantity(row, qty, total)
	if qty > total then qty = total end

	-- get gem icon for the row
	local gemText = self.gemQuantity[row]

	-- if we don't have one
	if gemText == nil then
		-- make one
		gemText = FontString:new(self.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
		self.gemQuantity[row] = gemText

		-- position it
		local previous = self.gemsHeader
		if row > 1 then
			previous = self.gemIcons[row - 1]
		end
		gemText:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 370, -8)
		gemText:SetHeight(18)
		gemText:SetFontSize(15)
	end

	gemText:SetText('' .. qty .. '/' .. total)
	if qty == total then
		gemText:SetTextColor(0,1,0)
	else
		gemText:SetTextColor(1,0,0)
	end
	gemText:Show()
end


-- display an enchant icon in a row
function ShoppingListTab:SetEnchantIcon(row, enchantId)

	-- get enchant icon for the row
	local enchantIcon = self.enchantIcons[row]

	-- if we don't have one
	if enchantIcon == nil then
		-- make one
		enchantIcon = EnchantLinkIconAndText:new(nil, self.scrollParent)
		self.enchantIcons[row] = enchantIcon
		enchantIcon:SetScript("OnMouseDown", function()
			self:SearchForEnchant(row)
		end)			

		-- position it
		if row == 1 then
			enchantIcon:SetPoint("TOPLEFT", self.enchantsHeader, "BOTTOMLEFT", 0, -12)
			enchantIcon:SetPoint("RIGHT", self.scrollParent, "RIGHT", -30, 0)
		else
			enchantIcon:SetPoint("TOPLEFT", self.enchantIcons[row - 1], "BOTTOMLEFT", 0, -7)
			enchantIcon:SetPoint("RIGHT", self.scrollParent, "RIGHT", -30, 0)
		end
		
		-- size it
		enchantIcon:SetWidth(24)
		enchantIcon:SetHeight(24)
		enchantIcon:SetFontSize(15)

		-- give it a nice border
		enchantIcon:SetRoundBorder()

		enchantIcon:UseSpellName()
	end

	enchantIcon:SetEnchantId(enchantId)

	enchantIcon:Show()
end

-- display a gem icon in a row
-- gemInfo is {id, enchantId, color, count }
function ShoppingListTab:SetEnchantQuantity(row, qty, total)
	if qty > total then qty = total end

	-- get gem icon for the row
	local enchantText = self.enchantQuantity[row]

	-- if we don't have one
	if enchantText == nil then
		-- make one
		enchantText = FontString:new(self.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
		self.enchantQuantity[row] = enchantText

		-- position it
		local previous = self.enchantsHeader
		if row > 1 then
			previous = self.enchantIcons[row - 1]
		end
		enchantText:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 370, -8)
		enchantText:SetHeight(18)
		enchantText:SetFontSize(15)
	end

	enchantText:SetText('' .. qty .. '/' .. total)
	if qty == total then
		enchantText:SetTextColor(0,1,0)
	else
		enchantText:SetTextColor(1,0,0)
	end
	enchantText:Show()
end

function ShoppingListTab:SearchForItem(itemName)
	if self.isAuctionHouseVisible then
		QueryAuctionItems(itemName, nil, nil, 0, 0, 0, 0, 0, 0, 0)
	end
end

function ShoppingListTab:SearchForGem(row)
	self:SearchForItem(self.gemLinks[row].itemName)
end

function ShoppingListTab:SearchForEnchant(row)
	self:SearchForItem(self.enchantIcons[row].itemName)
end

function ShoppingListTab:SearchForEnchantMaterial(row)
	self:SearchForItem(self.enchantMaterialLinks[row].itemName)
end


-- display an enchant material icon in a row
function ShoppingListTab:SetEnchantMaterialIcon(row, itemId)
	-- get enchant material icon for the row
	local materialIcon = self.enchantMaterialIcons[row]

	-- if we don't have one
	if materialIcon == nil then
		-- make one
		materialIcon = ItemIcon:new(nil, self.scrollParent)
		self.enchantMaterialIcons[row] = materialIcon
		materialIcon:SetScript("OnMouseDown", function()
			self:SearchForEnchantMaterial(row)
		end)

		-- position it
		local previous = self.enchantMaterialsHeader
		if row > 1 then
			previous = self.enchantMaterialIcons[row - 1]
		end
		materialIcon:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 0, -7)

		-- size it
		materialIcon:SetWidth(24)
		materialIcon:SetHeight(24)

		-- give it a nice border
		materialIcon:SetRoundBorder()
	end

	materialIcon:Show()

	-- make a link for the optimized gem
	local itemLink = select(2, GetItemInfo(itemId))

	materialIcon:SetItemLink(itemLink)

	-- if we didn't get one, its because WoW is slow
	if not itemLink and itemId then
		-- when WoW finally returns the link, set the icon / tooltip
		RegisterItemInfoCallback(itemId, function(name, link)
			materialIcon:SetItemLink(link)
		end)
	end
end


-- display an enchant material link in a row
function ShoppingListTab:SetEnchantMaterialLink(row, itemId)
	-- get gem icon for the row
	local materialLink = self.enchantMaterialLinks[row]

	-- if we don't have one
	if materialLink == nil then
		-- make one
		materialLink = ItemLinkText:new(nil, self.scrollParent)
		self.enchantMaterialLinks[row] = materialLink
		materialLink:SetScript("OnMouseDown", function()
			self:SearchForEnchantMaterial(row)
		end)

		-- position it
		local previous = self.enchantMaterialsHeader
		if row > 1 then
			previous = self.enchantMaterialIcons[row - 1]
		end
		materialLink:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 30, -8)
		materialLink:SetPoint("RIGHT", self, "RIGHT", -30, 0)
		materialLink:SetHeight(18)
		materialLink:SetFontSize(15)
	end

	materialLink:Show()

	materialLink:SetItemId(itemId)
	materialLink.itemId = itemId
end

-- display a gem icon in a row
-- gemInfo is {id, enchantId, color, count }
function ShoppingListTab:SetEnchantMaterialQuantity(row, qty, total)
	if qty > total then qty = total end

	-- get gem icon for the row
	local enchantText = self.enchantMaterialQuantity[row]

	-- if we don't have one
	if enchantText == nil then
		-- make one
		enchantText = FontString:new(self.scrollParent, nil, "ARTWORK", "GameFontNormalLarge")
		self.enchantMaterialQuantity[row] = enchantText

		-- position it
		local previous = self.enchantMaterialsHeader
		if row > 1 then
			previous = self.enchantMaterialIcons[row - 1]
		end
		enchantText:SetPoint("TOPLEFT", previous, "BOTTOMLEFT", 370, -8)
		enchantText:SetHeight(18)
		enchantText:SetFontSize(15)
	end

	enchantText:SetText('' .. qty .. '/' .. total)
	if qty == total then
		enchantText:SetTextColor(0,1,0)
	else
		enchantText:SetTextColor(1,0,0)
	end
	enchantText:Show()
end

function ShoppingListTab:CalculateItems()
	-- build a map of missing gem-ids -> {id, color, enchantid, count, total}
	local gemList = {}
	for slotNum, badGems in pairs(itemDiffs.gems) do
		--badGems: {current: array of enchant ids, optimized: (array of {id, color, enchantId})
		for i = 1, #badGems.optimized do
			if badGems.badGems[i] then
				local goodGem = badGems.optimized[i]
				if goodGem.id ~= 0 then
					local gem = gemList[goodGem.id]
					if gem == nil then
						gemList[goodGem.id] = {id = goodGem.id, enchantId = goodGem.enchantId, color = goodGem.color, count = 0, total = 1}
					else
						gem.total = gem.total + 1
					end
				end
			end
		end
	end

	local enchantList = {}
	for slot, enchantData in sortSlots(itemDiffs.enchants) do
		local id = getEnchantItemId(enchantData.optimized) or enchantData.optimized
		local qty = enchantList[id]
		if qty then
			qty.total = qty.total + 1
		else
			qty = { count = 0, total = 1, optimized = enchantData.optimized }
			enchantList[id] = qty
		end
	end

	local enchantMaterials = {}
	for slot, enchantData in pairs(itemDiffs.enchants) do
		addEnchantMaterials(enchantMaterials, enchantData.optimized)
	end
	
	--substract any inventory we already have in the bank
	for i = 1, #AmrBankItemsAndCounts do
		local itemId = getItemIdFromLink(AmrBankItemsAndCounts[i].link)
		if itemId then
			local gem = gemList[itemId]
			if gem then
				gem.count = gem.count + AmrBankItemsAndCounts[i].count
			else 
				local alternateGemId = gemDuplicates[itemId]
				if alternateGemId then
					gem = gemList[alternateGemId]
					if gem then
						gem.count = gem.count + AmrBankItemsAndCounts[i].count
					end
				end
			end
			local material = enchantMaterials[itemId]
			if material then
				material.count = material.count + AmrBankItemsAndCounts[i].count
			end
			local enchant = enchantList[itemId]
			if enchant then
				enchant.count = enchant.count + AmrBankItemsAndCounts[i].count
			end
		end
	end

	ScanBags()

	--substract any inventory we already have in bags
	for i = 1, #AmrBagItemsWithCount do
		local itemId = getItemIdFromLink(AmrBagItemsWithCount[i].link)
		if itemId then
			local gem = gemList[itemId]
			if gem then
				gem.count = gem.count + AmrBagItemsWithCount[i].count
			else 
				local alternateGemId = gemDuplicates[itemId]
				if alternateGemId then
					gem = gemList[alternateGemId]
					if gem then
						gem.count = gem.count + AmrBagItemsWithCount[i].count
					end
				end
			end
			local material = enchantMaterials[itemId]
			if material then
				material.count = material.count + AmrBagItemsWithCount[i].count
			end
			local enchant = enchantList[itemId]
			if enchant then
				enchant.count = enchant.count + AmrBagItemsWithCount[i].count
			end
		end
	end

	return gemList, enchantList, enchantMaterials
end

function ShoppingListTab:Update()
	
	local gemList, enchantList, enchantMaterials = self:CalculateItems()

	-- update the UI
	local lastControl = nil
	local row = 1
	for gemId, gemInfo in spairs(gemList) do
		self:SetGemIcon(row, gemInfo)
		self:SetGemText(row, gemInfo)
		self:SetGemQuantity(row, gemInfo.count, gemInfo.total)
		lastControl = self.gemIcons[row]
		row = row + 1
	end

	-- hide any extra gem icons
	for i = row, #self.gemIcons do
		self.gemIcons[i]:Hide()
		self.gemLinks[i]:Hide()
		self.gemQuantity[i]:Hide()
	end

	-- hide / show the gems header, and position the enchant headers
	if row > 1 then
		self.gemsHeader:Show()
		self.gemsQuantityHeader:Show()
		self.enchantsHeader:SetPoint("TOPLEFT", self.gemIcons[row - 1], "BOTTOMLEFT", 0, -15)
	else
		self.gemsHeader:Hide()
		self.gemsQuantityHeader:Hide()
		self.enchantsHeader:SetPoint("TOPLEFT", self.scrollParent, "TOPLEFT", 0, 0)
	end

	row = 1
	for slot, enchant in spairs(enchantList) do
		self:SetEnchantIcon(row, enchant.optimized)
		self:SetEnchantQuantity(row, enchant.count, enchant.total)
		lastControl = self.enchantIcons[row]
		row = row + 1
	end

	-- hide any extra enchant icons
	for i = row, #self.enchantIcons do
		self.enchantIcons[i]:Hide()
		self.enchantQuantity[i]:Hide()
	end

	-- hide / show the enchants header, and position the enchant materials headers
	if row > 1 then
		self.enchantsHeader:Show()
		self.enchantsQuantityHeader:Show()
		self.enchantMaterialsHeader:SetPoint("TOPLEFT", self.enchantIcons[row - 1], "BOTTOMLEFT", 0, -15)
	else
		self.enchantsHeader:Hide()
		self.enchantsQuantityHeader:Hide()
		self.enchantMaterialsHeader:SetPoint("TOPLEFT", self.scrollParent, "TOPLEFT", 0, 0)
	end

	row = 1
	for itemId, count in spairs(enchantMaterials) do
		self:SetEnchantMaterialIcon(row, itemId)
		self:SetEnchantMaterialLink(row, itemId)
		self:SetEnchantMaterialQuantity(row, count.count, count.total)
		lastControl = self.enchantMaterialIcons[row]
		row = row + 1
	end

	for i = row, #self.enchantMaterialIcons do
		self.enchantMaterialIcons[i]:Hide()
		self.enchantMaterialLinks[i]:Hide()
		self.enchantMaterialQuantity[i]:Hide()
	end

	if row == 1 then
		self.enchantMaterialsHeader:Hide()
		self.enchantMaterialsQuantityHeader:Hide()
	else
		self.enchantMaterialsHeader:Show()
		self.enchantMaterialsQuantityHeader:Show()
	end

	-- fix up the scrollbar length
	if lastControl then
		local height = self.scrollParent:GetTop() - lastControl:GetBottom()
		self.scrollParent:SetHeight(height)
		if height < self.scrollFrame:GetHeight() then
			self.scrollFrame.ScrollBar:Hide()
		else
			self.scrollFrame:Show()
			self.scrollFrame.ScrollBar:Show()
		end
		self.stamp:Hide()
		self.shoppingPanel:Show()
	else
		self.scrollFrame.ScrollBar:Hide()
		self.shoppingPanel:Hide()
		self.stamp:Show()
	end
end


function ShoppingListTab:OnEvent(frame, event, ...)
	local handler = self["On_" .. event]
	if handler then
		handler(self, ...)
	end
end

function ShoppingListTab:On_AUCTION_HOUSE_SHOW()
	self.isAuctionHouseVisible = true
end

function ShoppingListTab:On_AUCTION_HOUSE_CLOSED()
	self.isAuctionHouseVisible = false
end

function ShoppingListTab:Send()
	local gemList, enchantList, enchantMaterials = self:CalculateItems()

	local items = {}
	if AmrSendSettings.SendGems then
		for k,v in pairs(gemList) do
			local needed = v.total - v.count
			if needed > 0 then
				items[k] = needed
			end
		end
	end

	if AmrSendSettings.SendEnchants then
		for k,v in pairs(enchantList) do
			local needed = v.total - v.count
			if needed > 0 then
				items[k] = needed
			end
		end
	end

	if AmrSendSettings.SendEnchantMaterials then
		for k,v in pairs(enchantMaterials) do
			local needed = v.total - v.count
			if needed > 0 then
				items[k] = needed
			end
		end
	end

	local chatType = nil
	if AmrSendSettings.SendToType == "party" then
		chatType = "PARTY"
	elseif AmrSendSettings.SendToType == "guild" then
		chatType = "GUILD"
	elseif AmrSendSettings.SendToType == "raid" then
		chatType = "RAID"
	elseif AmrSendSettings.SendToType == "channel" then
		chatType = "CHANNEL"
	else
		chatType = "WHISPER"
	end

	local message = "Mr. Robot says I need"
	local count = 0
	for k, v in pairs(items) do
		local _, link = GetItemInfo(k)
		if link then
			message = message .. " " .. v .. "x " .. link
			count = count + 1
			if count == 3 then
				tinsert(self.messageQueue, {message = message, chatType = chatType, chatChannel = AmrSendSettings.SendTo})
				count = 0
				message = "Mr. Robot says I need"
			end
		end
	end

	if count > 0 then
		tinsert(self.messageQueue, {message = message, chatType = chatType, chatChannel = AmrSendSettings.SendTo})
	end

	if self.outstandingMessage == 0 then
		self:SendNextMessage()
	end
end

function ShoppingListTab:SendNextMessage()
	while #self.messageQueue > 0 do
		local entry = self.messageQueue[1]
		table.remove(self.messageQueue, 1)
		-- if entry.chatType ~= 'WHISPER' then
		-- 	self.outstandingMessage = 1
		-- end
		SendChatMessage(entry.message, entry.chatType, nil, entry.chatChannel)
		-- if entry.chatType ~= 'WHISPER' then
		-- 	break
		-- end
	end
end

-- function ShoppingListTab:On_CHAT_MSG_CHANNEL()
-- 	self.outstandingMessage = 0
-- 	self.SendNextMessage()
-- end

-- function ShoppingListTab:On_CHAT_MSG_GUILD()
-- 	self.outstandingMessage = 0
-- 	self.SendNextMessage()
-- end

-- function ShoppingListTab:On_CHAT_MSG_PARTY()
-- 	self.outstandingMessage = 0
-- 	self.SendNextMessage()
-- end

-- function ShoppingListTab:On_CHAT_MSG_PARTY_LEADER()
-- 	self.outstandingMessage = 0
-- 	self.SendNextMessage()
-- end

-- function ShoppingListTab:On_CHAT_MSG_RAID()
-- 	self.outstandingMessage = 0
-- 	self.SendNextMessage()
-- end